%% Funzione che calcola gli spostamenti in modalità triassiale per i Tilt Link
function [X,Y,Z,Xlocal,Ylocal,Zlocal,HShift,HShift_local,AlfaX,AlfaY,Azimuth,...
    Speed_local,Speed,Acceleration_local,Acceleration,TempDef_TL,ARRAYdateTL,...
    ErrTiltLink,MAGdef_TL] = triax_TL(IDcentralina,DTcatena,rTL,ACCdef_TL,...
    ACCdefRis_TL,MAGdef_TL,TempDef_TL,SpeTL,PsTL,NodoTiltLink,tolleranzaAcc,...
    tolleranzaMag,DatiElabTiltLink,segnoNS,segnoEO,MEMS,Ndevst,Wdevst,ARRAYdateTL,...
    Tmax,Tmin,NuovoZeroTL,NdatiMedia,Ndatidespike,ErrTiltLink,margine,datainiTL,FileName)
 
%% Inizializzazione
fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'triax_TL function started';
fprintf(fileID,fmt,text);

if NuovoZeroTL == 1
    if NdatiMedia > Ndatidespike
        Ndati = NdatiMedia;
    else
        Ndati = Ndatidespike;
    end
    ini = round(Ndati/2)+1;
    if rem(Ndati,2) == 0
        ini = ini+1;
    end
    clear NDati
    ini = ini + margine;
    if ini < 6
        ini = 6;
    end
    [letture,~]=size(DatiElabTiltLink);
    if ini > letture
        ini = letture-1;
    end
    if Ndevst ~= 0 % Allora prendo tutti i dati e solo in seguito considero i nuovi, a valle della funzione filtro
        ini = 1;
    end
    ACCdefRis_TL = ACCdefRis_TL(ini:end,:);
    TempDef_TL = TempDef_TL(ini:end,:);
    DatiElabTiltLink = DatiElabTiltLink(ini:end,:);
    ARRAYdateTL = ARRAYdateTL(ini:end,1); 
    ErrTiltLink = ErrTiltLink(ini:end,:);
end

%% Controllo e correzione dei campi magnetici
[rA,cA] = size(ACCdef_TL); % righe -> date, colonna -> nodi
conf_acc = zeros(rA,cA);
contM = 0; % contatore correzioni campi magnetici
contT = rA*cA;

% Se le accelerazioni variano meno della confidenza, NON cambio i valori di
% cambio magnetico e prendo quelli della lettura precedente
for d = 2:rA
    % seconda lettura e successive, confronto i risultati dei magnetometri
    % e degli accelerometri
    conf_acc(d,:) = abs(ACCdef_TL(d,:) - ACCdef_TL(d-1,:));
    for dd = 1:cA
        if abs(conf_acc(d,dd)) < tolleranzaMag  % SOGLIA ACCELERAZIONE
           MAGdef_TL(d,dd) = MAGdef_TL(d-1,dd);
           contM = contM+1;
        end
    end
end

text = ['' num2str(contM) ' corrections of magnetometers executed on a total amount of ' num2str(contT)...
    ' data, which represent the ' num2str(contM*100/contT) '% for Tilt Link V'];
fprintf(fileID,fmt,text);

if NuovoZeroTL == 1
    ACCdef_TL = ACCdef_TL(ini:end,:);
    MAGdef_TL2 = MAGdef_TL(ini:end,:);
else
    MAGdef_TL2 = MAGdef_TL;
end

%% Definisco i dati
Nnodi = rTL;
[r,~] = size(ACCdef_TL); % Numero di dati
[Ndati,~] = size(ARRAYdateTL);
ax = zeros(r,Nnodi);
ay = zeros(r,Nnodi);
az = zeros(r,Nnodi);
mx = zeros(r,Nnodi);
my = zeros(r,Nnodi);
mz = zeros(r,Nnodi);
for i=1:Nnodi
    ax(:,i) = ACCdef_TL(:,(i-1)*3+1); % ax
    ay(:,i) = ACCdef_TL(:,(i-1)*3+2:(i-1)*3+2); % ay
    az(:,i) = ACCdef_TL(:,(i-1)*3+3:(i-1)*3+3); % az
    mx(:,i) = MAGdef_TL2(:,(i-1)*3+1); % mx
    my(:,i) = MAGdef_TL2(:,(i-1)*3+2:(i-1)*3+2); % my
    mz(:,i) = MAGdef_TL2(:,(i-1)*3+3:(i-1)*3+3); % mz
end

%% Costruzione delle matrici spostamento e rotazione
NordSud = zeros(Nnodi,Ndati); % in riga i nodi, in colonna le date
EstOvest = zeros(Nnodi,Ndati); % in riga i nodi, in colonna le date
Zlocal = zeros(Nnodi,Ndati);
 
% parametri per il calcolo
SpeTL = SpeTL(2:end,1); % salto il segmento di pertinenza dell'ancora
c = 1;

% Inizio del ciclo di elaborazione
text = 'Triaxial Elaboration of Tilt Link V started';
fprintf(fileID,fmt,text);

% Inizializzo le matrici
deltaNS = zeros(rTL,1);
deltaEO = zeros(rTL,1);
deltaZ = zeros(rTL,1);
BECCHEGGIO = zeros(rTL,1);
ROLLIO = zeros(rTL,1);
IMBARDATA = zeros(rTL,1);
qf = zeros(rTL,4);
qfy = zeros(rTL,4);
for jj = 1:Ndati
    for jjj=1:rTL
        axb = ax(jj,jjj)';
        ayb = ay(jj,jjj)';
        azb = az(jj,jjj)';
        mxb = mx(jj,jjj)';
        myb = my(jj,jjj)';
        mzb = mz(jj,jjj)';
        SP = SpeTL(jjj);
        [DNS,DEO,Dz,becc,roll,imba,q,qy] = QuaternioniASE(axb,ayb,azb,mxb,myb,mzb,SP,MEMS,FileName);
        deltaNS(jjj) = DNS;
        deltaEO(jjj) = DEO;
        deltaZ(jjj) = Dz;
        BECCHEGGIO(jjj) = becc;
        ROLLIO(jjj) = roll;
        IMBARDATA(jjj) = imba;
        qf(jjj,:) = q;
        qfy(jjj,:) = qy;
        dq = q-qy;
        if any(dq>0.000001)
            text = (['Cicle Number ' num2str(jj) ' during Quaternion Calculation']);
            text2 = (['Node Number ' num2str(jjj)]);
            fprintf(fileID,fmt,text);
            fprintf(fileID,fmt,text2);
        end     
    end
% Le seguenti matrici sono organizzate come segue:
% - ciascuna riga è relativa a un nodo (1a riga = fondo catena);
% - ciascuna colonna è relativa a una data.
   NordSud(:,c) = deltaNS;
   EstOvest(:,c) = deltaEO;
   Zlocal(:,c) = deltaZ;
   c = c+1;
end

text = 'Quaternion calculation executed';
fprintf(fileID,fmt,text);

% dNS e dEO raccolgono i dati del singolo nodo nella singola data
dNS = diff(NordSud,1,2);
dEO = diff(EstOvest,1,2);
dZ = diff(Zlocal,1,2);

%% Cambio di segno alle direzioni!
if segnoNS == 0
   dNS = -1*dNS;
end
if segnoEO == 0
   dEO = -1*dEO;
end
    
%% Controllo delle risultanti di accelerazione e campo magnetico
clear r
clear rr
clear c
clear cc
ACCdefRis_TL = ACCdefRis_TL';  % Nodi in riga, date in colonna
[r,c] = size(ACCdefRis_TL);
[rr,cc] = size(NordSud);

% controllo che le matrici con le risultanti delle accelerazioni e 
% le matrici con i dati di spostamento abbiano le stesse dimensioni
if r~=rr
    text = '---Warning! Number of row of displacement data do not correspond to the number of acceleration cosine vector!---';
    fprintf(fileID,fmt,text);
end
if c~=cc
    text = '---Warning! Number of column of displacement data do not correspond to the number of acceleration cosine vector!---';
    fprintf(fileID,fmt,text);
end
clear i
clear j
cont = 1; % contatore
cont2 = 1; % contatore
cont3 = 1; % contatore
TempDef_TL = TempDef_TL';
textA = 'There are not correction of Tilt Link V based on acceleration vectors filter';
textA2 = 'There are not correction of Tilt Link V based on uncalibrated acceleration vectors';
textT = 'There are not correction of Tilt Link V based on temperature filter';
for j = 2:c % Data
    for i = 1:r % Nodo
        % se il valore assoluto della differenza è maggiore della
        % tolleranza, pongo gli spostamenti giornalieri pari a 0
        if abs(ACCdefRis_TL(i,j)-ACCdefRis_TL(i,j-1)) > tolleranzaAcc
            dNS(i,j-1) = 0;
            dEO(i,j-1) = 0;
            dZ(i,j-1) = 0;  
            textA = ['' num2str(cont) ' correction executed for Tilt Link V - Acceleration vector filter!'];
            cont = cont+1;
        end
        if ACCdefRis_TL(i,j) < 0.9 || ACCdefRis_TL(i,j) > 1.3 % Il nodo è fuori taratura! 
            dNS(i,j-1) = 0;
            dEO(i,j-1) = 0;
            dZ(i,j-1) = 0;
            TempDef_TL(i,j) = TempDef_TL(i,j-1);
            textA2 = ['' num2str(cont) ' correction executed for Tilt Link V - uncalibrated Acceleration vector!'];
            cont3 = cont3+1;
        end
    end
end

FileTemperature = ['' IDcentralina '-' DTcatena '-TL-Therm.csv'];
if isfile(FileTemperature) == 1
    DatiRaw = csvread(FileTemperature);
    [rDR,cDR] = size(DatiRaw);
    DatiRaw(:,1) = DatiRaw(:,1) + 730000;
else
    rDR = 1;
    cDR = 1;
end
for b = 1:c % Data
    for a = 1:r % Nodo
        % NON considero i dati al di sopra dei 80 °C o al di sotto dei -30 °C! 
        if TempDef_TL(a,b) > Tmax || TempDef_TL(a,b) < Tmin
            cont2 = cont2+1;
            if b == 1
                if isfile(FileTemperature) == 1
                    RawDate = find(DatiRaw(:,1)<=datenum(datainiTL));
                    if isempty(RawDate) == 1
                        cc = 2;
                        while cc <= c
                            if TempDef_TL(a,cc) > Tmax || TempDef_TL(a,cc) < Tmin
                                cc = cc+1;
                            else
                                break
                            end
                        end
                        TempDef_TL(a,b) = TempDef_TL(a,cc);
                    else
                        if isnan(DatiRaw(RawDate(end),a+1)) == 0
                            TempDef_TL(a,b) = DatiRaw(RawDate(end),a+1);
                            ErrTiltLink(b,a) = 0.5;
                            wardat = 'Temperature data of Tilt Link nodes corrected using Raw Data of reference Csv file.';
                            fprintf(fileID,fmt,wardat);
                        else
                            cc = 2;
                            while cc <= c
                                if TempDef_TL(a,cc) > Tmax || TempDef_TL(a,cc) < Tmin
                                    cc = cc+1;
                                else
                                    break
                                end
                            end
                            TempDef_TL(a,b) = TempDef_TL(a,cc);
                        end
                    end
                else
                    cc = 2;
                    while cc <= c
                        if TempDef_TL(a,cc) > Tmax || TempDef_TL(a,cc) < Tmin
                            cc = cc+1;
                        else
                            break
                        end
                    end
                    TempDef_TL(a,b) = TempDef_TL(a,cc);
                end
            else
                TempDef_TL(a,b) = TempDef_TL(a,b-1);
                dNS(a,b-1) = 0;
                dEO(a,b-1) = 0;
                dZ(a,b-1) = 0;
                ErrTiltLink(b,a) = 0.5;
            end
            textT = ['' num2str(cont2) ' correction executed for Tilt Link V - Temperature filter!'];
        end
    end
end

if  rDR~=1 && cDR~=1 && isempty(DatiRaw) == 0
    RawDate1 = find(DatiRaw(:,1)<=ARRAYdateTL(1));
    if isempty(RawDate1) == 1
        RawDate2 = 1;
    elseif RawDate1(end) == rDR
        RawDate2 = find(ARRAYdateTL(:,1)>DatiRaw(end,1));
    else
        RawDate2 = find(ARRAYdateTL(:,1)>DatiRaw(RawDate1(end)+1,1));
    end
else
    RawDate1 = [];
    RawDate2 = 1;
end
if isempty(RawDate1) == 0 && isempty(RawDate2) == 0
    Dati = [DatiRaw(1:RawDate1(end),:); ARRAYdateTL(RawDate2(1):end) TempDef_TL(:,RawDate2(1):end)'];
elseif isempty(RawDate1) == 1 && isempty(RawDate2) == 0
    Dati = [ARRAYdateTL TempDef_TL'];
else
    Dati = DatiRaw;
end
% Elimino appoggio più vecchio di un mese
RawDate3 = find(Dati(:,1)<now-30);
if isempty(RawDate3) == 0
    [rDati,~] = size(Dati);
    if RawDate3(end) == rDati
    else
        Dati = Dati(RawDate3(end)+1:end,:);
    end
end
if isfile(FileTemperature) == 1
    delete(FileTemperature);
end
Dati(:,1) = Dati(:,1) - 730000;
csvwrite(FileTemperature,Dati);

TempDef_TL = TempDef_TL';

fprintf(fileID,fmt,textA);
fprintf(fileID,fmt,textA2);
fprintf(fileID,fmt,textT);
fclose(fileID);
            
% azzeramenti di alcuni nodi in particolare
[dNS,dEO,dZ] = azzeramenti(IDcentralina,DTcatena,dNS,dEO,dZ,NodoTiltLink,FileName);

% Filtro
[dNS,dEO,dZ] = filtro(dNS,dEO,dZ,Ndevst,Wdevst,FileName);
if NuovoZeroTL == 1 && Ndevst ~= 0
    if NdatiMedia > Ndatidespike
        NdatiF = NdatiMedia;
    else
        NdatiF = Ndatidespike;
    end
    ini = round(NdatiF/2)+1;
    if rem(NdatiF,2) == 0
        ini = ini+1;
    end
    clear NDatiF
    iniST = round(Wdevst/2);
    if rem(Wdevst,2) == 0
        iniST = iniST+1;
    end
    iniST = iniST + margine;
    if iniST > ini
        ini = iniST;
    end
    if ini < 6
        ini = 6;
    end
    dNS = dNS(:,ini:end);
    dEO = dEO(:,ini:end);
    dZ = dZ(:,ini:end);
    TempDef_TL = TempDef_TL(ini:end,:);
    DatiElabTiltLink = DatiElabTiltLink(ini:end,:);
    ARRAYdateTL = ARRAYdateTL(ini:end,1); 
    ErrTiltLink = ErrTiltLink(ini:end,:);
end
    
%% Finalizzo i calcoli
[rNS,cNS] = size(dNS);
sommaX = zeros(rTL,1);
Xlocal = zeros(rNS,cNS+1); % locale nello spazio, cumulato nel tempo
AlfaX = zeros(rNS,cNS+1); % Angoli
sommaY = zeros(rTL,1);
Ylocal = zeros(rNS,cNS+1);
AlfaY = zeros(rNS,cNS+1); % Angoli
sommaZ = zeros(rNS,cNS);
Zlocal = zeros(rNS,cNS+1);
X = zeros(rNS,cNS+1); % cumulato nel tempo e nello spazio
Y = zeros(rNS,cNS+1); 
Z = zeros(rNS,cNS+1);
HShift = zeros(rNS,cNS+1); % massima pendenza cumulato nel tempo e nello spazio
HShift_local = zeros(rNS,cNS+1); % massima pendenza locale
Azimuth = zeros(rNS,cNS+1); % azimut
azim = zeros(rNS,cNS+1); % matrice di appoggio per il calcolo dell'azimuth
Speed = zeros(rTL,cNS+1); % Velocità 2D Cumulata
Speed_local = zeros(rTL,cNS+1); % Velocità 2D locale
Acceleration = zeros(rTL,cNS+1); % Accelerazione 2D Cumulata
Acceleration_local = zeros(rTL,cNS+1); % Accelerazione 2D Locale

% Recupero i dati già elaborati
if NuovoZeroTL == 1
   [rE,cE] = size(DatiElabTiltLink);
   cont = 3;
   n = 1;
   while cont<=cE
         sommaX(n,1) = cell2mat(DatiElabTiltLink(1,cont))';
         Xlocal(n,1) = sommaX(n,1);
         X(n,1) = cell2mat(DatiElabTiltLink(1,cont+3))';
         sommaY(n,1) = cell2mat(DatiElabTiltLink(1,cont+1))';
         Ylocal(n,1) = sommaY(n,1);
         Y(n,1) = cell2mat(DatiElabTiltLink(1,cont+4))';
         for j = 1:rTL
             AlfaX(j,1) = asind(Xlocal(j,1)/SpeTL(j));
             AlfaY(j,1) = asind(Ylocal(j,1)/SpeTL(j));
         end
         Zlocal(n,1) = cell2mat(DatiElabTiltLink(1,cont+2))';
         Z(n,1) = cell2mat(DatiElabTiltLink(1,cont+5))';
         HShift(n,1) = cell2mat(DatiElabTiltLink(1,cont+6))';
         HShift_local(n,1) = cell2mat(DatiElabTiltLink(1,cont+7))';
         Azimuth(n,1) = cell2mat(DatiElabTiltLink(1,cont+8))';
         Speed(n,1:rE) = cell2mat(DatiElabTiltLink(:,cont+10))';
         Speed_local(n,1:rE) = cell2mat(DatiElabTiltLink(:,cont+11))';
         Acceleration(n,1:rE) = cell2mat(DatiElabTiltLink(:,cont+12))';
         Acceleration_local(n,1:rE) = cell2mat(DatiElabTiltLink(:,cont+13))';
         cont=cont+16;
         n = n+1;
   end
else
    Zlocal(:,1) = SpeTL;
    Z(:,1) = PsTL(2:end);
end

% elaboro i dati nuovi
for iii = 1:cNS
    Xlocal(:,iii+1) = sum(dNS(:,1:iii),2)+sommaX(:,1);
    Ylocal(:,iii+1) = sum(dEO(:,1:iii),2)+sommaY(:,1);
    for j = 1:rTL
        AlfaX(j,iii+1) = asind(Xlocal(j,iii+1)/SpeTL(j));
        AlfaY(j,iii+1) = asind(Ylocal(j,iii+1)/SpeTL(j));
    end
    sommaZ(:,iii+1) = sum(dZ(:,1:iii),2);
    X(:,iii+1) = cumsum(Xlocal(:,iii+1));
    Y(:,iii+1) = cumsum(Ylocal(:,iii+1));
    Z(:,iii+1) = cumsum(sommaZ(:,iii+1))+ Z(:,1);
    HShift(:,iii+1) = (X(:,iii+1).^2+Y(:,iii+1).^2).^0.5;
    HShift_local(:,iii+1) = (Xlocal(:,iii+1).^2+Ylocal(:,iii+1).^2).^0.5;
    Zlocal(:,iii+1) = sommaZ(:,iii+1) + SpeTL; % Zeta è il singolo abbassamento di quel nodo
    for rr = 1:rTL
        azim(rr,iii) = (acos(abs(X(rr,iii))/HShift(rr,iii)))*180/3.141592654; % Angolo Teta in gradi 0° - 90°
        segnoNS = sign(X(rr,iii));
        segnoEO = sign(Y(rr,iii));
        % L'azimuth si calcola con NS = 0, positivo in senso orario
        % (90° = Est)
        if segnoNS == 1 && segnoEO == 1 % quadrante 1
            Azimuth(rr,iii+1) = azim(rr,iii); % Teta lo tengo come è (1 quadrante)
        elseif segnoNS == -1 && segnoEO == 1 % quadrante 2
               Azimuth(rr,iii+1) = 180 - azim(rr,iii); % 180-teta
        elseif segnoNS == -1 && segnoEO == -1 % quadrante 3
               Azimuth(rr,iii+1) = 180 + azim(rr,iii); % 180+teta
        elseif segnoNS == 1 && segnoEO == -1 % quadrante 4
               Azimuth(rr,iii+1) = 360 - azim(rr,iii); % 360-teta
        elseif segnoNS == 0 && segnoEO == -1 % 270°
               Azimuth(rr,iii+1) = 270;
        elseif segnoNS == -1 && segnoEO == 0 % 180°
               Azimuth(rr,iii+1) = 180;
        end
    end
end
Azimuth = real(Azimuth);

%% Calcolo velocità di spostamento giornaliera
[numDate,~] = size(ARRAYdateTL); % numero di date
d = 1;
p = 1;
diffDate = 0;
n = 1;
period = 1; % calcolo giornaliero
ContSUP = [];
for dd = 1:numDate
    while diffDate < period
          d = d+1;  
          if d > numDate % Se d supera le date disponibili, esco dal ciclo while
              break
          end
          diffDate = ARRAYdateTL(d) - ARRAYdateTL(p);
    end
    if d >numDate
        break
    end
    ContSUP(n,1) = d; %#ok<*AGROW> % Creo matrice indici dell'estremo superiore della differenza
    ContINF(n,1) = p; % Creo matrice indici dell'estremo inferiore della differenza
    p = p+1; % passo alla data di partenza successiva 
    d = p; % resetto il conto di d
    n = n+1;
    diffDate = 0;
end

check = isempty(ContSUP);
if check == 0
    [nDate,~] = size(ContSUP);
    for s = 1:rTL
        N = 1;
        for dd = 1:nDate
            Speed(s,ContSUP(N,1)) = (HShift(s,ContSUP(N,1))-HShift(s,ContINF(N,1)))/(ARRAYdateTL(ContSUP(N,1))-ARRAYdateTL(ContINF(N,1)));
            Speed_local(s,ContSUP(N,1)) = (HShift_local(s,ContSUP(N,1))-HShift_local(s,ContINF(N,1)))/(ARRAYdateTL(ContSUP(N,1))-ARRAYdateTL(ContINF(N,1)));
            Acceleration(s,ContSUP(N,1)) = (Speed(s,ContSUP(N,1))-Speed(s,ContINF(N,1)))/(ARRAYdateTL(ContSUP(N,1))-ARRAYdateTL(ContINF(N,1)));
            Acceleration_local(s,ContSUP(N,1)) = (Speed_local(s,ContSUP(N,1))-Speed_local(s,ContINF(N,1)))/(ARRAYdateTL(ContSUP(N,1))-ARRAYdateTL(ContINF(N,1)));
            N = N+1;
        end
    end
end

% Approssimo i dati con il corretto numero di cifre decimali
[X,Y,Z,Xlocal,Ylocal,Zlocal,HShift,HShift_local,Azimuth,Speed,...
    Speed_local,Acceleration,Acceleration_local,TempDef_TL] = approx(X,Y,Z,...
    Xlocal,Ylocal,Zlocal,HShift,HShift_local,Azimuth,Speed,Speed_local,...
    Acceleration,Acceleration_local,TempDef_TL,FileName);

% Riordino matrice errori
[r,~] = size(ErrTiltLink);
Matrice_err = zeros(r,rTL);
for i = 1:r % date
    d = 1;
    for n = 1:rTL % nodi
        j = 1;
        err = ErrTiltLink(i,d:d+6);
        while j <= 7
            if err(1,j) == 1
                Matrice_err(i,n) = 1;
                break
            end
            if err(1,j) == 0.5
                Matrice_err(i,n) = 0.5;
            end
            j = j+1;
        end
        d = d+7;
    end
end
ErrTiltLink = Matrice_err';
    
text = 'Tilt Link V triaxial calculation executed correctly. triax_TL function ended';
fileID = fopen(FileName,'a');
fmt = '%s \r';
fprintf(fileID,fmt,text);
fclose(fileID);

end